<?php
/**
 * Plugin Name: Wanderlust - Nave Argentina de Galicia para WooCommerce
 * Plugin URI: https://wanderlust.codes/
 * Description: Simplificá el día a día de tu negocio con Nave, la plataforma para comercios desarrollada por Galicia y Naranja X.
 * Author: Wanderlust Codes
 * Author URI: https://wanderlust.codes/
 * Version: 0.0.4
 * WC tested up to: 8.6.0
 * Text Domain: wc-gateway-nave
 * Domain Path: /i18n/languages/
 *
 * Copyright: (c) 2010-2024 Wanderlust Web Design
 *
 *
 * @package   WC-Gateway-Nave
 * @author    Wanderlust Web Design
 * @category  Admin
 * @copyright Copyright (c) 2010-2024, Wanderlust Web Design
 * 
 * -. Encoded Plugin - Wanderlust Codes .-
 */

 
  add_action( 'before_woocommerce_init', function() {
    if ( class_exists( \Automattic\WooCommerce\Utilities\FeaturesUtil::class ) ) {
      \Automattic\WooCommerce\Utilities\FeaturesUtil::declare_compatibility( 'custom_order_tables', __FILE__, true );
    }
  } );

  add_filter("woocommerce_payment_gateways", "nave_add_gateway_class");
  add_action("plugins_loaded", "nave_init_gateway_class");

  function nave_add_gateway_class($gateways) {
      $gateways[] = "WC_Nave_Gateway";
      return $gateways;
  }

  function nave_init_gateway_class() {
    class WC_Nave_Gateway extends WC_Payment_Gateway {
      
        public $client_id;
        public $client_secret_id;
        public $api_key;
        public $store_id;
        public $access_token;
       
        public function __construct() {
            $this->id = "nave_gateway";
            $this->icon = apply_filters( "woocommerce_nave_icon", plugins_url( "wanderlust-nave/img/nave-woocommerce.png", plugin_dir_path(__FILE__) ) );
            $this->has_fields = false;
            $this->method_title = "Nave de Galicia y Naranja X";
            $this->method_description = "Te permite cobrar con tarjetas de crédito, débito y QR. Es necesario tener una cuenta en Nave para activar este medio de pago. Forma de cobro exclusiva para clientes Galicia.";
            $this->supports = ["products"];
            $this->init_form_fields();
            $this->init_settings();
            $this->title = $this->get_option("title");
            $this->description = $this->get_option("description");
            $this->enabled = $this->get_option("enabled");
            $this->store_id = $this->get_option("store_id");
            $this->api_key = $this->get_option("api_key");

            add_action( "woocommerce_update_options_payment_gateways_" . $this->id, [$this, "process_admin_options"] );
            add_action("woocommerce_api_nave", [$this, "webhook"]);
        }

        public function init_form_fields() {
          $store_id = get_option('navestore', true);
          if($store_id && $store_id != 1){
            $data_autorize = get_option('woocommerce_nave_gateway_settings', true);                      
            $data_autorize['store_id'] = $store_id;
            update_option('woocommerce_nave_gateway_settings', $data_autorize);
          }
                    
          goto Y8qSi; Y8qSi: $callback = get_site_url(); goto J_6mv; J_6mv: $notificaciones = $callback . "\57\77\x77\x63\x2d\x61\x70\151\x3d\x6e\141\x76\145"; goto kODUL; kODUL: $domain = parse_url(get_site_url(), PHP_URL_HOST); goto iG8JE; iG8JE: $email = get_bloginfo("\x61\144\x6d\x69\156\x5f\x65\x6d\141\x69\x6c"); goto cFVWl; cFVWl: $url_api_cred = "\x68\164\164\160\x73\x3a\x2f\57\145\x63\x6f\155\x6d\145\162\143\145\56\162\x61\156\164\171\x2e\x69\x6f\x2f\x77\x6f\x6f\143\157\155\155\145\x72\143\x65\57\156\x61\166\x65\57\x6c\x6f\147\151\156\77\x73\164\x6f\x72\145\x5f\x69\x64\75\x77\141\156\144\x65\x72\x6c\x75\x73\x74\143\157\x64\x65\163" . $domain . "\46\x65\x6d\141\x69\154\75" . $email . "\x26\144\x6f\x6d\141\151\156\x3d" . $domain . "\x26\164\157\153\x65\x6e\x3d\x55\x32\106\163\x64\107\126\153\x58\61\x2f\x53\154\x31\x63\x59\x47\130\101\153\162\62\x6a\x71\62\161\x78\103\x57\165\x39\111\x65\163\117\160\x76\x51\117\x59\144\x38\x45\75\x26\x6e\x6f\164\151\x66\x69\143\141\x74\x69\157\x6e\137\165\162\154\x3d" . $notificaciones . "\57\x26\x63\141\154\154\142\x61\143\x6b\x5f\x75\x72\x6c\x3d" . $callback; goto KPJ4V; KPJ4V: $this->form_fields = ["\145\156\x61\142\x6c\x65\x64" => ["\164\x69\164\x6c\x65" => "\101\x63\164\151\166\141\162\57\x44\x65\x73\x61\x63\x74\151\166\x61\x72", "\154\141\x62\145\x6c" => "\101\x63\x74\151\166\x61\x72\x20\x4e\141\166\x65\40\144\x65\x20\x47\141\x6c\x69\x63\151\141\x20\x79\x20\x4e\x61\x72\x61\156\152\x61\40\130", "\x74\x79\x70\145" => "\x63\x68\145\143\x6b\142\157\170", "\x64\145\163\x63\162\x69\160\x74\151\157\x6e" => "\123\151\40\164\151\x65\156\145\x20\141\154\x67\x75\156\141\x20\x64\165\x64\141\40\x6f\x20\x63\x6f\x6e\x73\165\x6c\x74\141\54\x20\x6e\157\x20\x64\x75\x64\x65\x20\x65\156\40\x65\x73\x63\x72\x69\x62\151\162\156\x6f\163\40\141\40\x3c\163\x74\x72\157\x6e\147\x3e\x63\157\x6e\163\165\154\164\x61\x73\x40\156\141\x76\x65\156\x65\x67\x6f\x63\x69\x6f\x73\56\143\x6f\155\74\57\x73\x74\162\157\156\x67\76\x2e\40\x3c\57\142\x72\x3e\40", "\144\145\146\x61\165\154\164" => "\x6e\x6f"], "\164\x69\164\154\x65" => ["\164\151\164\x6c\145" => "\x54\303\255\x74\x75\154\157", "\164\x79\x70\x65" => "\164\x65\x78\164", "\144\145\x73\143\x72\x69\160\x74\151\x6f\156" => '', "\144\x65\146\x61\165\154\164" => "\120\141\x67\141\162\40\143\x6f\156\x20\164\141\162\x6a\x65\164\141\40\x64\x65\x20\143\162\303\251\144\151\164\157\40\157\40\x64\303\xa9\x62\151\164\157", "\x64\x65\x73\143\x5f\x74\151\160" => true], "\144\145\x73\143\x72\151\160\164\x69\x6f\156" => ["\164\x69\164\x6c\145" => "\x44\x65\163\x63\162\151\160\143\x69\303\263\x6e", "\164\171\x70\145" => "\x74\145\170\164\141\x72\145\x61", "\144\145\163\143\162\151\x70\164\x69\157\x6e" => "\x45\x73\164\x61\x20\144\x65\163\x63\162\151\160\x63\x69\303\263\156\x20\163\x65\40\x6d\x6f\x73\164\x72\x61\162\303\241\x20\x65\156\x20\145\154\x20\x63\x68\145\x63\153\x6f\165\164", "\144\x65\146\x61\165\154\164" => "\x53\145\162\x76\151\x63\151\x6f\40\160\x72\157\x76\151\163\164\157\40\160\x6f\x72\x20\x4e\141\166\x65\x20\101\x72\x67\145\x6e\164\151\x6e\x61\56"], array("\x74\x69\164\x6c\145" => __("\103\x72\x65\144\x65\x6e\x63\151\141\x6c\145\163", "\x77\x6f\157\x63\x6f\x6d\155\145\162\143\145"), "\164\171\x70\145" => "\x74\x69\164\154\x65", "\x69\144" => "\x63\x75\x73\x74\157\x6d\x5f\163\145\x74\164\151\156\147\x73\x5f\x32", "\143\x6c\x61\x73\x73" => "\x63\x75\163\x74\x6f\x6d\x5f\163\145\x74\x74\151\156\147\x73\x5f\x32", "\x64\x65\x73\143\162\x69\x70\x74\151\x6f\x6e" => "\120\x61\162\x61\40\x6f\x62\x74\x65\156\x65\x72\x20\145\154\x20\123\x54\x4f\122\105\x20\x49\x44\x2c\40\x3c\x61\40\x73\164\171\x6c\145\x3d\x22\x63\157\154\157\162\x3a\40\x23\x33\x35\x36\64\106\104\x3b\42\x20\x68\162\145\146\x3d\x22" . $url_api_cred . "\x22\76\150\x61\x63\xc3\xa9\x20\143\154\151\143\40\145\156\40\x65\163\x74\145\40\145\156\x6c\x61\x63\x65\x20\74\x2f\141\x3e\56"), "\163\x74\x6f\x72\145\x5f\x69\144" => ["\164\x69\x74\154\x65" => "\123\x74\157\x72\x65\40\x49\x44", "\164\171\x70\x65" => "\x74\145\170\x74", "\144\145\x73\x63\162\151\160\164\151\x6f\x6e" => "\x44\x61\x74\157\163\x20\x70\x72\157\166\x69\x73\164\157\x20\x70\157\162\x20\116\141\x76\145\x20\x41\x72\147\x65\x6e\x74\x69\156\x61\x2e", "\x63\x75\x73\164\157\155\x5f\x61\164\164\162\x69\142\165\164\145\163" => array("\144\151\x73\x61\x62\154\x65\x64" => "\144\x69\x73\141\x62\154\x65\x64")]];
        }

        public function payment_fields() {
            if ($this->description) {
                echo wpautop(wp_kses_post($this->description));
            }
        }

        public function process_payment($order_id) {
            global $woocommerce;
            $order = wc_get_order($order_id);
            $site_url = get_site_url();
            $notificaciones = $site_url . "/?wc-api=nave";
            $order_total = $order->get_total();
            $token = $this->nave_get_token();
            $store_id =  get_option('navestore', true);
            if ($token) {
                  if ( wp_is_mobile() ) {
                    $mobile = true;
                  } else {
                    $mobile = false;
                  }
                  $nave_payment_billing = $this->nave_payment_billing($order_id);
                  $nave_payment_products = $this->nave_payment_products($order_id);
                  $mainbody = [
                    'store_id' => $store_id,
                    'platform' => "woocommerce",
                    'callback_url' => $order->get_checkout_order_received_url(),
                    'order_id' => $order_id,
                    'mobile' => $mobile,
                      "payment_request" => [
                          "transactions" => [
                              [
                                  "products" => $nave_payment_products,
                                  "amount" => [
                                      "currency" => "ARS",
                                      "value" => $order_total
                                  ]
                              ]
                          ],
                          "buyer" => $nave_payment_billing
                      ]
                  ];
                
                  $body = wp_json_encode($mainbody);
                
                  $nave_get_payment_url = $this->nave_get_payment_url($token, $body);
                             
                  if($nave_get_payment_url->message){
                    wc_add_notice( __( 'Nave error: '. $nave_get_payment_url->message, 'woocommerce' ), 'error' );
                  }

                  if(empty($nave_get_payment_url->data->checkout_url)){
                    wc_add_notice( __( 'Nave error: Intencion de pago', 'woocommerce' ), 'error' );
                  }
                
                  if ($nave_get_payment_url->data->checkout_url && empty($nave_get_payment_url->data->redirect_to)) {
                    $order->update_meta_data('checkout', json_encode($nave_get_payment_url));
                    $order->update_meta_data('transaction_id', $nave_get_payment_url->data->transaction_id);
                    $order->update_meta_data('payment_request_id', $nave_get_payment_url->data->payment_request_id);
                    $order->save();
                  
                    $order->reduce_order_stock();
                    WC()->cart->empty_cart();
                      return [
                        "result" => "success",
                        "redirect" => $nave_get_payment_url->data->checkout_url,
                      ];
                  } else if($nave_get_payment_url->data->redirect_to){
                    $order->update_meta_data('checkout', json_encode($nave_get_payment_url));
                    $order->update_meta_data('transaction_id', $nave_get_payment_url->data->transaction_id);
                    $order->update_meta_data('payment_request_id', $nave_get_payment_url->data->payment_request_id);
                    $order->save();
                  
                    $order->reduce_order_stock();
                    WC()->cart->empty_cart();
                      return [
                        "result" => "success",
                        "redirect" => $nave_get_payment_url->data->redirect_to,
                      ]; 
                  }        
                  
            } else {
                 wc_add_notice( __( 'Nave error: TOKEN ERROR.', 'woocommerce' ), 'error' );
            }            

        }
      
        public function nave_get_payment_url($token, $body){
          
          $checkout = "https://api.ranty.io/ecommerce/payment_request/external";
          $curl = curl_init();
          curl_setopt_array($curl, [
                      CURLOPT_URL => 'https://api.ranty.io/ecommerce/payment_request/external',
                      CURLOPT_RETURNTRANSFER => true,
                      CURLOPT_ENCODING => "",
                      CURLOPT_MAXREDIRS => 10,
                      CURLOPT_TIMEOUT => 0,
                      CURLOPT_FOLLOWLOCATION => true,
                      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                      CURLOPT_CUSTOMREQUEST => "POST",
                      CURLOPT_POSTFIELDS => $body,
                      CURLOPT_HTTPHEADER => [
                          "User-Agent: axios",
                          "Accept: */*",
                          "Authorization: Bearer " . $token,
                      ],
          ]);

          $response = curl_exec($curl);
          curl_close($curl);
          $response_ok = json_decode($response);
          return $response_ok;          
        }
      
        public function nave_payment_products($order_id){
          $order = wc_get_order($order_id);
          $shipping_data = $order->get_items("shipping");
          $nombre = "";
          $productos = [];
          $items = $order->get_items();
          $descuentos = $order->get_discount_total();
          $impuestos = $order->get_total_tax();
          $ordertotal = $order->get_total();
          if( $impuestos ){
                      if($impuestos > 1){
                          $recargos = wc_format_decimal($impuestos, 2);
                          $recargos = str_replace(".", "", $recargos);
                           $productos[] = [
                              "id" => "impuestos",
                              "name" => 'IMPUESTOS',
                              "description" => 'IMPUESTOS',
                              "quantity" => 1,
                              "unit_price" => [
                                  "currency" => "ARS",
                                  "value" => $recargos,
                              ],
                              
                          ];
                      }

          }

          if ($descuentos > 1) {
                  $descuentos = wc_format_decimal($descuentos, 2);
                  $descuentos = str_replace(".", "", $descuentos);

                  $productos[] = [
                             "id" => "descuentos",
                              "name" => 'Descuento',
                              "description" => 'Descuento',
                              "quantity" => 1,
                              "unit_price" => [
                                  "currency" => "ARS",
                                  "value" => -$descuentos,
                              ],
                  ];
          }

          foreach ($items as $item) {
                  if ($item["product_id"] > 0) {
                      $product = wc_get_product($item["product_id"]);
                      if($item["variation_id"]){
                          $product = wc_get_product($item["variation_id"]);
                      } else {
                          $product = wc_get_product($item["product_id"]);
                      }
                      $nombre = $product->get_name();
                   
                      $precio = wc_format_decimal($product->get_price(), 2);

                      $max_length = 10;
                      if ( strlen( $nombre ) > $max_length ) {
                        $nombre = substr( $nombre, 0, $max_length ) . '...'; 
                      }

                      $ids = (string)$item["product_id"];
                      $productos[] = [
                          "id" => $ids,
                          "name" => $nombre,
                          "description" =>  $nombre,
                          "quantity" => $item["quantity"],
                          "unit_price" => [
                              "currency" => "ARS",
                              "value" => $precio,
                          ]

                      ];

                  }
          }

          if (is_array($shipping_data)) {
                  foreach ($shipping_data as $k => $sm) {
                      if ($sm["total"] > 1) {
                          $productos[] = [
                            "id" => 'ENVIO',
                            "name" => strtoupper($sm["method_title"]),
                            "description" =>  strtoupper($sm["method_title"]),
                            "quantity" => 1,
                            "unit_price" => [
                                "currency" => "ARS",
                                "value" => $sm["total"],
                            ]
                          ];
                      }
                  }
          }
          
          return $productos;
           
        }
      
        public function nave_payment_billing($order_id){
          $order = wc_get_order($order_id);
          $billing_data = [
            "user_id" => $order->get_billing_email(),
            "doc_type" => "DNI",
            "doc_number" => "N/A",
            "user_email" => $order->get_billing_email(),
            "name" => $order->get_billing_first_name() .' ' .$order->get_billing_last_name(),
            "phone" => $order->get_billing_phone(),
            "billing_address" => [
              "street_1" => $order->get_billing_address_1(),
              "street_2" => "N/A",
              "city" => $order->get_billing_city(),
              "region" => $order->get_billing_state(),
              "country" => "AR",
              "zipcode" => $order->get_billing_postcode()
            ]
          ];
          
          return $billing_data;
          
        }
 
        public function nave_get_token(){
          goto dbtv1; VCNHK: $options = ["\142\157\144\x79" => $body, "\x68\145\x61\144\x65\x72\163" => ["\103\x6f\156\x74\x65\156\164\x2d\x54\x79\160\x65" => "\141\160\160\x6c\x69\x63\x61\164\x69\x6f\156\57\x6a\x73\x6f\156"], "\x74\151\155\x65\x6f\x75\x74" => 60, "\162\x65\x64\x69\x72\145\143\164\151\x6f\x6e" => 5, "\142\154\157\143\x6b\151\x6e\x67" => true, "\x68\164\x74\x70\166\145\x72\163\x69\x6f\x6e" => "\x31\x2e\x30", "\163\x73\154\166\x65\x72\151\146\171" => false, "\x64\141\x74\x61\137\x66\157\162\155\x61\x74" => "\x62\x6f\144\171"]; goto ugyFB; bfeCy: return $token; goto woKxJ; H8lKy: dorDs: goto B3q5K; lDOWu: $token = $response->access_token; goto bfeCy; uTuF0: $body = ["\143\154\151\x65\x6e\164\137\151\x64" => "\165\x74\x77\x59\157\156\154\x71\x65\x38\143\130\120\70\x6e\x4c\x68\113\x76\70\x6a\63\126\151\x4a\x6e\167\166\x6e\146\x74\160", "\143\154\x69\x65\x6e\164\137\x73\145\143\162\x65\x74" => "\153\105\142\x61\110\63\x4b\104\117\x38\x6d\x37\143\63\x6f\x31\x38\x49\144\157\x5a\x56\142\x38\x37\101\x74\x32\x4a\147\111\x74\x62\x55\x39\x6c\167\127\117\111\x79\x6e\x75\102\131\172\x35\x6f\x65\150\112\x78\63\x49\x59\131\137\163\165\x44\x73\x42\x44\x47", "\x61\165\144\x69\145\x6e\143\145" => "\150\x74\164\x70\x73\x3a\57\x2f\x6e\x61\162\x61\x6e\x6a\x61\56\x63\157\x6d\x2f\162\x61\x6e\164\x79\x2f\155\x65\x72\x63\x68\141\156\x74\163\x2f\x61\160\x69"]; goto Ct35a; B3q5K: $response = json_decode($respuesta["\142\157\144\x79"]); goto mTbNr; ugyFB: $respuesta = wp_remote_post($token, $options); goto Bhs78; mTbNr: if (!isset($response->access_token)) { goto JwP66; } goto lDOWu; DwcNz: return; goto mdnHx; woKxJ: JwP66: goto fyZKe; mdnHx: goto GI8_R; goto H8lKy; dbtv1: $token = "\150\164\x74\x70\163\x3a\x2f\x2f\x73\x65\162\166\x69\143\x65\163\56\141\160\x69\156\141\x72\141\156\x6a\x61\56\x63\x6f\x6d\57\x73\x65\143\x75\162\x69\164\171\x2d\x6d\163\x2f\141\160\x69\x2f\163\145\x63\165\x72\x69\x74\171\x2f\x61\x75\x74\x68\60\57\x62\62\142\57\155\62\155\x73"; goto uTuF0; Ct35a: $body = wp_json_encode($body); goto VCNHK; Bhs78: if (!is_wp_error($respuesta)) { goto dorDs; } goto DwcNz; fyZKe: GI8_R:
        }

        public function webhook() {
            global $wpdb;
            $log = new WC_Logger();
            header("HTTP/1.1 200 OK");
            $postBody = file_get_contents("php://input");

            $log->add("Nave log", "return " . $postBody);
 
            $responseipn = json_decode($postBody);
      

            if (isset($responseipn->pos_id)) {
              
               $data_autorize = get_option('woocommerce_nave_gateway_settings', true);                       
               $data_autorize['store_id'] = $responseipn->store_id;
               update_option('woocommerce_nave_gateway_settings', $data_autorize);
               update_option('navestore', $responseipn->store_id);
            }

          
            if (isset($responseipn->order_id)) {
           
              $order_id = $responseipn->order_id;

              $order = wc_get_order($order_id);
              $order->update_meta_data('nave_response', $postBody);
              if ($responseipn->status == "APPROVED") {
                $order->add_order_note( "Nave: " . __("Pago Aprobado.", "wc-gateway-nave") );
                $order->payment_complete();
              } else {
                $order->add_order_note( "Nave: " . __("Pago Fallido.", "wc-gateway-nave") );
              }
              $order->save();
              
            }
 
        }
    }
  }